;;; Studio Tecnico Arch. Giuseppe Conte  
;;; via Roma, 28
;;; 72026 - San Pancrazio Salentino (BR) - Italy
;;;
;;; Plugin  : draw-circle-rhomb.scm
;;; Author  : Arch. Giuseppe Conte 
;;; Date    : 08 maggio 2002 -  Florence - Italy
;;; Revision: 11 giugno 2006
;;; 					10 dicembre 2007 update to TinyScheme
;;; Version : 2.4.1
;;; Last version at: http://xoomer.alice.it/lwcon/gimp/script-fu/draw-circle-rhomb.htm
;;; Help guide at  : http://xoomer.alice.it/lwcon/gimp/script-fu/draw-circle-rhomb.htm
;;; Required : Gimp 2.4.1 or last
;;;
;;; Description: 
;;; Draw rhomb in circle.
;;; -----------------------------------------------------------------------------
;;;
;;; License:
;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;; 
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;; 
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;;; Define the function:

(define (script-fu-draw-circle-rhomb inImage inLayer dx dy extRadius medRadius intRadius Lati )

	(let* (	(segment)
					(segment (make-vector 6))   
					(stepx dx)
					(stepy dy)
					(nlati Lati)
					(angolo)
					(arco)
					(alfa)
					(beta)
					(gamma)
					(gcount)
					(npoint)
	      )

		(set! angolo (/ 360 Lati))
		(set! arco (* angolo (/ 3.141592654 180)))

		(set! alfa 0)
		(set! beta (/ arco 2))

		(set! gcount 1)
		(set! npoint 6)

  
  (while (<= gcount nlati) 
  	
  		(set! alfa (+ alfa arco))
  		
  		(vector-set! segment 0 (+ (* extRadius (cos alfa)) stepx))
  		(vector-set! segment 1 (+ (- (* extRadius (sin alfa))) stepy))

  		(set! beta (+ beta arco))  		
  		(vector-set! segment 2 (+ (* medRadius (cos beta)) stepx))
  		(vector-set! segment 3 (+ (- (* medRadius (sin beta))) stepy))
  		
  		(set! gamma (+ alfa arco))
  		(vector-set! segment 4 (+ (* extRadius (cos gamma)) stepx))
  		(vector-set! segment 5 (+ (- (* extRadius (sin gamma))) stepy))		
  
		(gimp-pencil inLayer npoint segment )

  		(vector-set! segment 0 (+ (* intRadius (cos alfa)) stepx))
  		(vector-set! segment 1 (+ (- (* intRadius (sin alfa))) stepy))
  		(vector-set! segment 4 (+ (* intRadius (cos gamma)) stepx))
  		(vector-set! segment 5 (+ (- (* intRadius (sin gamma))) stepy))
		(gimp-pencil inLayer npoint segment )
				
  		(set! gcount (+ gcount 1))
	  	
	  	(gimp-displays-flush)
	     	
   );end while

  );;let
) ;;def

(script-fu-register
 "script-fu-draw-circle-rhomb"
 _"<Image>/_ATG/_Offset/D_raw circle-rhomb"
 "Draw rhomb in circle."
 "Arch. Giuseppe Conte <http://space.tin.it/edicola/lwcon/>"
 "2007, Giuseppe Conte"
 "10 dicembre 2007 - San Pancrazio Salentino (BR) - Italy"
 "RGB* GRAY* INDEXED*"
 SF-IMAGE "The Image" 0
 SF-DRAWABLE "The Layer" 0
 SF-ADJUSTMENT "X center" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Y center" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Exterior Radius" '(100 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Medius Radius" '(60 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Interior Radius" '(20 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Number Rhomb" '(3 0 9999 1 10 0 1)
)
